﻿namespace Example1_RoleOfPerson;

abstract record Person
{
    public string? FirstName { get; set; }
    public string? LastName { get; set; }
}

record Customer : Person
{
    public int TotalOrders { get; set; }
}

record Employee : Person
{
    public decimal Salary { get; set; }
    public DateOnly DateHired { get; set; }
}

record Helper : Person
{
    public bool Qualified { get; set; }
}

class Program
{
    static void Main(string[] args)
    {
        ProcessPerson
        (
            new Employee
            {
                FirstName = "Jiri", LastName = "Vesely", Salary = 1000,
                DateHired = DateOnly.FromDateTime(DateTime.Today)
            }
        );
    }

    static void ProcessPerson(Person person)
    {

        Console.WriteLine($"ProcessPerson: processing {person} ... ");
    }
}
